<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| NEURON infusion package
| Copyright  2005 - 2006 Alexey "martini" Martyashev
| e-mail: mr.owner@gmail.com
| www: http://php-fusion.int.ru/
+----------------------------------------------------*/
if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."neuron/locale/".$settings['locale'].".php")) {
        // Load the locale file matching the current site locale setting.
        include INFUSIONS."neuron/locale/".$settings['locale'].".php";
} else {
        // Load the infusion's default locale file.
        include INFUSIONS."neuron/locale/English.php";
}

// Infusion general information
$inf_title = $locale['neu00'];
$inf_description = $locale['neu01'];
$inf_version = "1.0";
$inf_developer = "martini";
$inf_email = "mr.owner@gmail.com";
$inf_weburl = "http://php-fusion.int.ru/";

$inf_folder = "neuron"; // The folder in which the infusion resides.
$inf_admin_image = BASEDIR.INFUSIONS."neuron/neuron.gif"; // Leave blank to use the default image.
$inf_admin_panel = "neuron_admin.php"; // The admin panel filename if required.

$inf_link_name = ""; // if not required replace $locale['xxx102']; with "";
$inf_link_url = ""; // The filename you wish to link to.
$inf_link_visibility = "0"; // 0 - Guest / 101 - Member / 102 - Admin / 103 - Super Admin.

$inf_newtables = 1; // Number of new db tables to create or drop.
$inf_insertdbrows = 3; // Numbers rows added into created db tables.
$inf_altertables = 0; // Number of db tables to alter (upgrade).
$inf_deldbrows = 0; // Number of db tables to delete data from.

// Delete any items not required here.
$inf_newtable_[1] = "neuron_settings (
id SMALLINT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
panel SMALLINT(2) UNSIGNED DEFAULT '0' NOT NULL,
time SMALLINT(2) UNSIGNED DEFAULT '30' NOT NULL,
PRIMARY KEY (id)
) TYPE=MyISAM;";


$inf_insertdbrow_[1] = "neuron_settings (panel,time) VALUES('0','30')";
$inf_insertdbrow_[2] = "neuron_settings (panel,time) VALUES('1','30')";
$inf_insertdbrow_[3] = "neuron_settings (panel,time) VALUES('2','30')";

$inf_droptable_[1] = "neuron_settings";
?>