<?php
/*---------------------------------------------------+
| NEURON infusion package
| Copyright  2005 - 2006 Alexey "martini" Martyashev
| e-mail: mr.owner@gmail.com
| www: http://php-fusion.int.ru/
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once "cpaint.php";

$cp = new cpaint();
$cp->register('shoutbox_update');
$cp->register('online_users_update');
$cp->register('forum_threads_list_update');
$cp->start('cp1251');
$cp->return_data();

function encode($str,$type )
{
// $type:
// 'w' - encodes from UTF to win
// 'u' - encodes from win to UTF

static $conv='';
if (!is_array ( $conv ))
{
$conv=array ();
for ( $x=128; $x <=143; $x++ )
{
$conv['utf'][]=chr(209).chr($x);
$conv['win'][]=chr($x+112);
}

for ( $x=144; $x <=191; $x++ )
{
$conv['utf'][]=chr(208).chr($x);
$conv['win'][]=chr($x+48);
}

$conv['utf'][]=chr(208).chr(129);
$conv['win'][]=chr(168);
$conv['utf'][]=chr(209).chr(145);
$conv['win'][]=chr(184);
}
if ( $type=='w' )
return str_replace ( $conv['utf'], $conv['win'], $str );
elseif ( $type=='u' )
return str_replace ( $conv['win'], $conv['utf'], $str );
else
return $str;
}

function forum_threads_list_update(){
global $db_prefix;
global $locale;
global $settings;
global $userdata;
global $cp;
$output = "";
$result = dbquery(
        "SELECT tf.*, tt.*, tu.user_id,user_name FROM ".$db_prefix."forums tf
        INNER JOIN ".$db_prefix."threads tt USING(forum_id)
        INNER JOIN ".$db_prefix."users tu ON tt.thread_lastuser=tu.user_id
        WHERE ".groupaccess('forum_access')." ORDER BY thread_lastpost DESC LIMIT 0,".$settings['numofthreads']
);
$i=0;
$output .= "<table cellpadding='0' cellspacing='1' width='100%' class='tbl-border'>\n<tr>\n";
        if ($theme_width == "100%") $output .= "<td class='tbl2'><span class='small'><b>".$locale['030']."</b></span></td>\n";
        $output .= "<td class='tbl2'><span class='small'><b>".$locale['031']."</b></span></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><span class='small'><b>".$locale['032']."</b></span></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><span class='small'><b>".$locale['033']."</b></span></td>
<td align='center' width='1%' class='tbl2' style='white-space:nowrap'><span class='small'><b>".$locale['034']."</b></span></td>
</tr>\n";
        while ($data = dbarray($result)) {
                if ($i % 2 == 0) { $row_color = "tbl1"; } else { $row_color = "tbl2"; }
                $reply_count = dbcount("(thread_id)", "posts", "thread_id='".$data['thread_id']."'");
                $data2 = dbarray(dbquery("SELECT post_id FROM ".$db_prefix."posts WHERE thread_id='".$data['thread_id']."' ORDER BY post_id DESC LIMIT 1"));
                $rstart = ($reply_count > 20 ? "rowstart=".((ceil($reply_count / 20)-1)*20)."&amp;" : "");
                $output .= "<tr>\n";
                if ($theme_width == "100%") {
                        $output .= "<td width='45%' class='$row_color'><span class='small'>".$data['forum_name']."</span></td>
<td width='55%' class='$row_color'><span class='small'><a href='".FORUM."viewthread.php?".$rstart."forum_id=".$data['forum_id']."&amp;thread_id=".$data['thread_id']."#post_".$data2['post_id']."' title='".$data['thread_subject']."'>".trimlink($data['thread_subject'], 30)."</a></span></td>\n";
                } else {
                        $output .= "<td width='100%' class='$row_color'><span class='small'><a href='".FORUM."viewthread.php?".$rstart."forum_id=".$data['forum_id']."&amp;thread_id=".$data['thread_id']."#post_".$data2['post_id']."' title='".$data['thread_subject']." (".$data['forum_name'].")'>".trimlink($data['thread_subject'], 30)."</a></span></td>\n";
                }
                $output .= "<td align='center' width='1%' class='$row_color' style='white-space:nowrap'><span class='small'>".$data['thread_views']."</span></td>
<td align='center' width='1%' class='$row_color' style='white-space:nowrap'><span class='small'>".($reply_count - 1)."</span></td>
<td align='center' width='1%' class='$row_color' style='white-space:nowrap'><span class='small'><a href='".BASEDIR."profile.php?lookup=".$data['thread_lastuser']."'>".$data['user_name']."</a></span></td>
</tr>\n";
                $i++;
        }
        if (iMEMBER) {
                $output .= "<tr>\n<td align='center' colspan='5' class='tbl1'><span class='small'><a href='".INFUSIONS."forum_threads_list_panel/my_threads.php'>".$locale['026']."</a> |
<a href='".INFUSIONS."forum_threads_list_panel/my_posts.php'>".$locale['027']."</a></span></td>\n</tr>\n";
        }
        $output .= "</table>\n";
        $cp->set_data($output);
}

function online_users_update(){
global $db_prefix;
global $locale;
global $settings;
global $userdata;
global $cp;
$output = "";
        $cond = ($userdata['user_level'] != 0 ? "'".$userdata['user_id']."'" : "'0' AND online_ip='".USER_IP."'");
        $result = dbquery("SELECT * FROM ".$db_prefix."online WHERE online_user=".$cond."");
        if (dbrows($result) != 0) {
                $result = dbquery("UPDATE ".$db_prefix."online SET online_lastactive='".time()."' WHERE online_user=".$cond."");
        } else {
                $name = ($userdata['user_level'] != 0 ? $userdata['user_id'] : "0");
                $result = dbquery("INSERT INTO ".$db_prefix."online (online_user, online_ip, online_lastactive) VALUES ('$name', '".USER_IP."', '".time()."')");
        }
        $result = dbquery("DELETE FROM ".$db_prefix."online WHERE online_lastactive<".(time()-60)."");

        $result = dbquery("SELECT * FROM ".$db_prefix."online WHERE online_user='0'");
        $guests = dbrows($result);
        $output .=  $locale['011'].$guests."<br>\n";
        $result = dbquery(
                "SELECT ton.*, user_id,user_name FROM ".$db_prefix."online ton
                LEFT JOIN ".$db_prefix."users tu ON ton.online_user=tu.user_id
                WHERE online_user!='0'"
        );
        $members = dbrows($result);
        if ($members != 0) {
                $i = 1;
                $output .=  $locale['012'];
                while($data = dbarray($result)) {
                        $output .=  "<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."' class='side'>".$data['user_name']."</a>";
                        if ($i != $members) $output .=  ", ";
                        $i++;
                }
                $output .=  "<br>\n";
        } else {
                echo $locale['013']."<br>\n";
        }
        $output .=  "<br><img src='".THEME."images/bullet.gif' alt=''> ".$locale['014'].number_format(dbcount("(user_id)", "users", "user_status<='1'"))."<br>\n";
        if ($settings['admin_activation'] == "1") echo "<img src='".THEME."images/bullet.gif' alt=''> ".$locale['015'].dbcount("(user_id)", "users", "user_status='2'")."<br>\n";
        $data = dbarray(dbquery("SELECT user_id,user_name FROM ".$db_prefix."users WHERE user_status='0' ORDER BY user_joined DESC LIMIT 0,1"));
        $output .=  "<img src='".THEME."images/bullet.gif' alt=''> ".$locale['016']."<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."' class='side'>".$data['user_name']."</a>\n";
        $cp->set_data($output);
}


function shoutbox_update($shout_message="",$shout_name=""){
global $db_prefix;
global $locale;
global $settings;
global $userdata;
global $cp;

$shout_message = encode($shout_message,"w");
$shout_name = encode($shout_name,"w");

if ($shout_message != "") {
        if (iMEMBER) {
                $shout_name = $userdata['user_id'];
        } elseif ($settings['guestposts'] == "1") {
                $shout_name = trim(stripinput($shout_name));
                $shout_name = preg_replace("(^[0-9]*)", "", $shout_name);
                if (isNum($shout_name)) $shout_name="";
        }
        $shout_message = str_replace("\n", " ", $shout_message);
        $shout_message = preg_replace("/^(.{255}).*$/", "$1", $shout_message);
        $shout_message = preg_replace("/([^\s]{25})/", "$1\n", $shout_message);
        $shout_message = trim(stripinput(censorwords($shout_message)));
        $shout_message = str_replace("\n", "<br>", $shout_message);
        if ($shout_name != "" && $shout_message != "") {
                if (dbcount("(*)", "shoutbox", "shout_message='$shout_message' AND shout_datestamp+84600>".time())) {
                        redirect("Location: ".FUSION_SELF.(FUSION_QUERY ? "?".FUSION_QUERY : ""));
                } else {
                        $result = dbquery("INSERT INTO ".$db_prefix."shoutbox (shout_name, shout_message, shout_datestamp, shout_ip) VALUES ('$shout_name', '$shout_message', '".time()."', '".USER_IP."')");
                }
        }
}

$output = "";
$result = dbquery("SELECT count(shout_id) FROM ".$db_prefix."shoutbox");
$numrows = dbresult($result, 0);
$result = dbquery(
        "SELECT * FROM ".$db_prefix."shoutbox LEFT JOIN ".$db_prefix."users
        ON ".$db_prefix."shoutbox.shout_name=".$db_prefix."users.user_id
        ORDER BY shout_datestamp DESC LIMIT 0,".$settings['numofshouts']
);
if (dbrows($result) != 0) {
        $i = 0;
        while ($data = dbarray($result)) {
                $output .= "<span class='shoutboxname'><img src='".THEME."images/bullet.gif' alt=''> ";
                if ($data['user_name']) {
                        $output .= "<a href='".BASEDIR."profile.php?lookup=".$data['shout_name']."' class='side'>".$data['user_name']."</a>\n";
                } else {
                        $output .= $data['shout_name']."\n";
                }
                $output .= "</span><br>\n<span class='shoutboxdate'>".showdate("shortdate", $data['shout_datestamp'])."</span>";
                if (iADMIN && checkrights("S")) {
                        $output .= "\n[<a href='".ADMIN."shoutbox.php?action=edit&amp;shout_id=".$data['shout_id']."' class='side'>".$locale['048']."</a>]";
                }
                $output .= "<br>\n<span class='shoutbox'>".parsesmileys($data['shout_message'])."</span><br>\n";
                if ($i != $numrows) $output .= "<br>\n";
        }
        if ($numrows > $settings['numofshouts']) {
                $output .= "<center>\n<img src='".THEME."images/bullet.gif' alt=''>
<a href='".INFUSIONS."shoutbox_panel/shoutbox_archive.php' class='side'>".$locale['126']."</a>
<img src='".THEME."images/bulletb.gif' alt=''></center>\n";
        }
} else {
        $output .= "<div align='left'>".$locale['127']."</div>\n";
}
$cp->set_data($output);
}
?>