<?php
/*---------------------------------------------------+
| NEURON infusion package
| Copyright  2005 - 2006 Alexey "martini" Martyashev
| e-mail: mr.owner@gmail.com
| www: http://php-fusion.int.ru/
+----------------------------------------------------*/
require_once "../../maincore.php";
// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."neuron/locale/".$settings['locale'].".php")) {
        // Load the locale file matching the current site locale setting.
        include INFUSIONS."neuron/locale/".$settings['locale'].".php";
} else {
        // Load the infusion's default locale file.
        include INFUSIONS."neuron/locale/English.php";
}
$result = dbquery("SELECT panel,time FROM ".DB_PREFIX."neuron_settings");
while ($data = dbarray($result)){
        $period[$data['panel']]        = $data['time'];
}
echo "function update_panel(element,auto) {
        //alert(refresh_state[element]);
        if (element == 0) {
                if (document.getElementById('shoutbox_response')) {
                        document.getElementById('shoutbox_response').innerHTML = loading_message;
                        if (auto == 0) {
                                cp.call(basedir+'infusions/neuron/neuron_core.php', 'shoutbox_update', shoutbox_results, document.getElementById('shout_message').value, document.getElementById('shout_name').value);
                                document.getElementById('shout_message').value = '';
                        } else {
                                cp.call(basedir+'infusions/neuron/neuron_core.php', 'shoutbox_update', shoutbox_results, '', '');
                        }
                }
        }
        if (element == 1) {
                if (document.getElementById('online_users_response')) {
                        document.getElementById('online_users_response').innerHTML = loading_message;
                        cp.call(basedir+'infusions/neuron/neuron_core.php', 'online_users_update', online_users_results);
                }
        }
        if (element == 2) {
                if (document.getElementById('forum_threads_list_response')) {
                        document.getElementById('forum_threads_list_response').innerHTML = loading_message;
                        cp.call(basedir+'infusions/neuron/neuron_core.php', 'forum_threads_list_update', forum_threads_list_results);
                }
        }
}

function shoutbox_results(result) {
        document.getElementById('shoutbox_response').innerHTML = result;
}

function online_users_results(result) {
        document.getElementById('online_users_response').innerHTML = result;
}

function forum_threads_list_results(result) {
        document.getElementById('forum_threads_list_response').innerHTML = result;
}

function refresh_panel(element,auto) {
        update_panel(element,auto);
                if (auto) {
                        if (refresh_state[element]) {
                                timeout_id[element] = setTimeout('refresh_panel('+element+',1)', timeout_period[element]);
                        }
                }
}

function turn_auto(element) {
        if (refresh_state[element] == 0) {
                document.getElementById(object_names[element]+'_auto').innerHTML = turn_off_label;
                refresh_state[element] = 1;
                timeout_id[element] =  setTimeout('refresh_panel('+element+',1)', timeout_period[element]);
        } else {
                document.getElementById(object_names[element]+'_auto').innerHTML = turn_on_label;
                refresh_state[element] = 0;
                clearTimeout(timeout_id[element]);
        }
}

function neuron_start() {
    for (var i = 0; i < 3; i++) {
                refresh_panel(i,1);
        }
}

basedir = '".BASEDIR."';
var cp = new cpaint();
cp.set_response_type('TEXT');
var loading_message = '".$locale['neu05']."';
var turn_on_label = '".$locale['neu06']."';
var turn_off_label = '".$locale['neu07']."';
var timeout_id = new Array();
var timeout_period = new Array(".($period[0]*1000).",".($period[1]*1000).",".($period[2]*1000).");
var object_names = new Array('shoutbox','online_users','forum_threads_list');
var refresh_state = new Array(0,0,0);";
?>